#include "fenetre_rs232.h"


///////////////////////////////////////////
// Creation de l'objet
RS232::RS232(QWidget *parent) : QDialog(parent)
{
        ui.setupUi(this);

  // on charge les donnees sur le disque dur
  charger();
}



///////////////////////////////////////////
// Fermer la fenetre et enregistrer
void RS232::on_pushButton_rs232_clicked()
{
  // on ferme la fenetre
  this->hide();

  // on sauve les resultats sur le disque dur
  sauver();

} 



///////////////////////////////////////////
// Sauver les donnees sur le disque dur
void RS232::sauver(void)
{
  // recuperation des donnees
  QString value1 = ui.lineEdit->text(); 

  QFile file;
  file.setFileName("config/config_rs232.ini");
  if( file.exists() )
    file.remove();
  file.open(QIODevice::Append | QIODevice::Text );
  QTextStream out(&file);
  out << value1;    
  file.close();

} 


///////////////////////////////////////////
// Charger les donnees sur le disque dur
void RS232::charger(void)
{
  QFile file;
  file.setFileName("config/config_rs232.ini");
  if( !file.exists() )
    return;      

  // creation des variables
  QString value1 = "COM1"; 


  file.open(QIODevice::ReadOnly | QIODevice::Text );
  QTextStream in(&file);
  QString line;
  line = in.readLine(); 
  value1 = line;
  file.close();

  ui.lineEdit->setText(value1); 

} 


///////////////////////////////////////////
// Connexion a l'appareil
int RS232::connexion(QextSerialPort *port)
{
  int retour = 0;

  // recuperation des donnees du port RS232
  QString nomport = ui.lineEdit->text();

  PortSettings settings;

  settings.BaudRate = BAUD9600;    // 9600 bauds

  settings.Parity = PAR_NONE;    // pas de parite

  settings.DataBits = DATA_8;   // 8 bits de donnees

  settings.StopBits = STOP_1;    // bit de stop 1.0

  settings.Timeout_Millisec = 500;    // delai de timeout fixe a 500ms
 
  // si la connexion existe deja, on la ferme
  if(port != NULL)
  {
	   port->close(); // on ferme le port
       delete port;
       port = NULL;
  }

  // connexion
  if(port == NULL)
  {
       port = new QextSerialPort(nomport,settings); 
  }

  // ouverture du port
  port->open(QIODevice::ReadWrite); // on ouvre le port

  // on regarde si le port est bien ouvert
  if(port->isOpen() != 1)
  {
	port->close();
    delete port;
    port = NULL;

    retour = -1;
  }
  else // le port est bien ouvert
  {
    // on remet tous les parametres pour etre sur qu'ils ont bien ete pris en compte
       port->setBaudRate(BAUD9600);    // 9600 bauds

       port->setFlowControl(FLOW_OFF); // pas de controle de flux

       port->setParity(PAR_NONE);    // pas de parite

       port->setDataBits(DATA_8);   // 8 bits de donnees

       port->setStopBits(STOP_1);    // bit de stop 1.0

//       port->setTimeout( 500 );    // reglage du timeout

       retour = (int)port;
  }


  return retour;
} 

