
/////////////////////////////////////////////
// VISCOVAC 212 : Display
QString TPG300::fctdisplay(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de DIS
  send_rs232("DIS R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("DIS", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");


  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : MTIME
QString TPG300::fctmtime(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de MTI
  send_rs232("MTI R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("MTI", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : OFFSET
QString TPG300::fctoffset(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de OFS
  send_rs232("OFS R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("OFS", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : TEMP
QString TPG300::fcttemp(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de TEM
  send_rs232("TEM R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("TEM", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : MOLWT
QString TPG300::fctmolwt(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de MOL
  send_rs232("MOL R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("MOL", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}



/////////////////////////////////////////////
// VISCOVAC 212 : VISC
QString TPG300::fctvisc(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de VIS
  send_rs232("VIS R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("VIS", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : SIGMA
QString TPG300::fctsigma(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de SIG
  send_rs232("SIG R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("SIG", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : BDIAM
QString TPG300::fctbdiam(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de BDI
  send_rs232("BDI R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("BDI", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : CDIAM
QString TPG300::fctcdiam(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de CDI
  send_rs232("CDI R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("CDI", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : BDENS
QString TPG300::fctbdens(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de BDE
  send_rs232("BDE R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("BDE", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : LIMITS
QString TPG300::fctlimits(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de LIM
  send_rs232("LIM R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("LIM", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}



/////////////////////////////////////////////
// VISCOVAC 212 : LOLIM
QString TPG300::fctlolim(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de LOL
  send_rs232("LOL R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("LOL", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : UPLIM
QString TPG300::fctuplim(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de UPL
  send_rs232("UPL R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("UPL", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : OUTPUT
QString TPG300::fctoutput(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de ANO
  send_rs232("ANO R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("ANO", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : ZERO
QString TPG300::fctzero(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de ZER
  send_rs232("ZER R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("ZER", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : FSCAL
QString TPG300::fctfscal(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de FSC
  send_rs232("FSC R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("FSC", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : PRINTER
QString TPG300::fctprinter(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de PRI
  send_rs232("PRI R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("PRI", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : SAMPL
QString TPG300::fctsampl(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de SAM
  send_rs232("SAM R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("SAM", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : INTVL
QString TPG300::fctintvl(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de INT
  send_rs232("INT R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("INT", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : IMAGE
QString TPG300::fctimage(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de IMA
  send_rs232("IMA R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("IMA", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : AUTOMATIC
QString TPG300::fctautomatic(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de AUT
  send_rs232("AUT R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("AUT", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : DATE
QString TPG300::fctdate(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de DAT
  send_rs232("DAT R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("DAT", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : TIME
QString TPG300::fcttime(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de TIM
  send_rs232("TIM R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("TIM", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : VAL
QString TPG300::fctval(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de VAL
  send_rs232("VAL R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("VAL", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : FRQ
QString TPG300::fctfrq(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de FRQ
  send_rs232("FRQ R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("FRQ", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : SIGNAL SCATTERING
QString TPG300::fctsignalscattering(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de SSC
  send_rs232("SSC R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("SSC", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : AMT
QString TPG300::fctamt(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de AMT
  send_rs232("AMT R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("AMT", "");

  return valeur; 
}


/////////////////////////////////////////////
// VISCOVAC 212 : RUN
QString TPG300::fctrun(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de RUN
  send_rs232("RUN R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("RUN", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : STOP
QString TPG300::fctstop(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de STP
  send_rs232("STP R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("STP", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : PRS
QString TPG300::fctprs(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de PRS
  send_rs232("PRS R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("PRS", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : STS
QString TPG300::fctsts(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de STS
  send_rs232("STS R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("STS", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : ERROR
QString TPG300::fcterror(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de ERR
  send_rs232("ERR R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("ERR", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : SRQ
QString TPG300::fctsrq(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de SRQ
  send_rs232("SRQ R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("SRQ", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : SMH
QString TPG300::fctsmh(void)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de SMH
  send_rs232("SMH R");

  // reception de la valeur
  valeur = receive_rs232();

  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("SMH", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : PAR
QString TPG300::fctpar(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de PAR
  send_rs232("PAR R" + QString::number(nn));

  // reception de la valeur
  valeur = valeur + QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("PAR", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace(QString::number(nn) + ",", "");

  return valeur; 
}

/////////////////////////////////////////////
// VISCOVAC 212 : COD
QString TPG300::fctcod(int nn)
{
  QString valeur_retour = "-1"; // par defaut, on met a -1

  if(port == NULL) // Il y a un probleme
    return valeur_retour;        

  QString valeur = "";

  // envoi de COD
  send_rs232("COD R" + QString::number(nn));

  // reception de la valeur
  valeur = QString::number(nn) + "=" + receive_rs232();


  // on retire <CR> et <LF>
  valeur = valeur.replace("\x0D", ""); // on supprime les caracteres de fin
  valeur = valeur.replace("\x0A", "");

  // on vire les espaces
  valeur = valeur.replace(" ", "");

  // on remplace les erreurs
  valeur = valeur.replace("IERR01", "Erreur - Signe ASCII interdit");
  valeur = valeur.replace("IERR02", "Erreur - Saturation de la mmoire pour l'entre des donnes");
  valeur = valeur.replace("IERR03", "Erreur - Saturation de la mmoire pour la sortie des donnes");
  valeur = valeur.replace("IERR04", "Erreur - Forme errone des instructions");
  valeur = valeur.replace("IERR05", "Erreur - Instruction commande  distance interdite");
  valeur = valeur.replace("IERR06", "Erreur - Identification interdite");
  valeur = valeur.replace("IERR07", "Erreur - Argument erron");
  valeur = valeur.replace("IERR08", "Erreur - Gamme de rglage dpasse par le haut ou le bas");
  valeur = valeur.replace("IERR09", "Erreur - Fonction non programmable");
  valeur = valeur.replace("IERR10", "Erreur - Commande  distance interdite");
  valeur = valeur.replace("IERR11", "Erreur - Accs interdit");

  // on vire le nom de la commande
  valeur = valeur.replace("COD", "");

  // on vire la reference au numero
  if(nn < 10)
    valeur = valeur.replace("W0" + QString::number(nn) + ",", "");
  else if(nn >= 10)
    valeur = valeur.replace("W" + QString::number(nn) + ",", "");

  return valeur; 
}






